#!/local/paths/perl -wT
#
# 2000/08/30 Sylvain Robitaille: Quick hack to get text out of a
#                                Berkeley DB data file.

use DB_File;

my ($key, $value);
my ($db_file) = @ARGV;

if(!defined $db_file) {
  die "Usage:\n $0 <filename>\n";
}

# Untaint input:
if( $db_file =~ m%^([^`\\<>|]+)$% ) {
  $db_file = $1;
} else {
  die "$db_file tainted\n";
}

# Open source and destination files:
tie %PW, "DB_File", "$db_file.db", O_RDONLY, 0444, $DB_HASH
   or die "can't dbopen $db_file: $!\n";
open  TXTPW, "> $db_file.txt"
   or die "can't open $db_file.txt: $!\n";

# Make sure we'll be writing to the output file:
my $oldfh = select TXTPW;

# translate the input:
while (($key,$value) = each %PW) {
  print "$key $value\n";
}

# Reset our stdout:
select $oldfh;

# Close files:
close TXTPW;
dbmclose %PW;

